| OGRE 1.11.1 Object-Oriented Graphics Rendering Engine

Public Member Functions | Static Public Member Functions | List of all members
Ogre::ParticleAffector Class Referenceabstract
Core » Effects

Abstract class defining the interface to be implemented by particle affectors. More...

`#include <OgreParticleAffector.h>`

Inheritance diagram for Ogre::ParticleAffector:
[legend]

## Public Member Functions
| ParticleAffector (ParticleSystem *parent)
virtual | ~ParticleAffector ()
| Virtual destructor essential. More...
virtual void | _affectParticles (ParticleSystem *pSystem, Real timeElapsed)=0
| Method called to allow the affector to 'do it's stuff' on all active particles in the system. More...
virtual void | _initParticle (Particle *pParticle)
| Method called to allow the affector to initialize all newly created particles in the system. More...
void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object. More...
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class. More...
const ParamDictionary * | getParamDictionary (void) const
String | getParameter (const String &name) const
| Generic parameter retrieval method. More...
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object. More...
const String & | getType (void) const
| Returns the name of the type of affector. More...
bool | setParameter (const String &name, const String &value)
| Generic parameter setting method. More...
void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method. More...

## Static Public Member Functions
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g. More...

## Detailed Description

Abstract class defining the interface to be implemented by particle affectors.

Remarks
  Particle affectors modify particles in a particle system over their lifetime. They can be grouped into types, e.g. 'vector force' affectors, 'fader' affectors etc; each type will modify particles in a different way, using different parameters.

  Because there are so many types of affectors you could use, OGRE chooses not to dictate the available types. It comes with some in-built, but allows plugins or applications to extend the affector types available. This is done by subclassing ParticleAffector to have the appropriate emission behaviour you want, and also creating a subclass of ParticleAffectorFactory which is responsible for creating instances of your new affector type. You register this factory with the ParticleSystemManager using addAffectorFactory, and from then on affectors of this type can be created either from code or through text particle scripts by naming the type.

  This same approach is used for ParticleEmitters (which are the source of particles in a system). This means that OGRE is particularly flexible when it comes to creating particle system effects, with literally infinite combinations of affector and affector types, and parameters within those types.

## Constructor & Destructor Documentation

## ◆ ParticleAffector()

Ogre::ParticleAffector::ParticleAffector | ( | ParticleSystem * | parent | ) |
| inline

## ◆ ~ParticleAffector()

virtual Ogre::ParticleAffector::~ParticleAffector | ( |  | ) |
| virtual

Virtual destructor essential.

## Member Function Documentation

## ◆ _initParticle()

virtual void Ogre::ParticleAffector::_initParticle | ( | Particle * | pParticle | ) |
| inline virtual

Method called to allow the affector to initialize all newly created particles in the system.

Remarks
  This is where the affector gets the chance to initialize it's effects to the particles of a system. The affector is expected to initialize some or all of the particles in the system passed to it, depending on the affector's approach.

Parameters

  pParticle | Pointer to a Particle to initialize.

Reimplemented in Ogre::RotationAffector, and Ogre::ColourImageAffector.

## ◆ _affectParticles()

virtual void Ogre::ParticleAffector::_affectParticles | ( | ParticleSystem * | pSystem,
|  | Real | timeElapsed
| ) |  |
| pure virtual

Method called to allow the affector to 'do it's stuff' on all active particles in the system.

Remarks
  This is where the affector gets the chance to apply it's effects to the particles of a system. The affector is expected to apply it's effect to some or all of the particles in the system passed to it, depending on the affector's approach.

Parameters

  pSystem | Pointer to a ParticleSystem to affect.
  timeElapsed | The number of seconds which have elapsed since the last call.

Implemented in Ogre::ColourFaderAffector2, Ogre::RotationAffector, Ogre::ColourFaderAffector, Ogre::LinearForceAffector, Ogre::DirectionRandomiserAffector, Ogre::DeflectorPlaneAffector, Ogre::ColourInterpolatorAffector, Ogre::ScaleAffector, and Ogre::ColourImageAffector.

## ◆ getType()

const String& Ogre::ParticleAffector::getType | ( | void |  | ) | const
| inline

Returns the name of the type of affector.

Remarks
  This property is useful for determining the type of affector procedurally so another can be created.

## ◆ getParamDictionary() [1/2]

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) |
| inline inherited

Retrieves the parameter dictionary for this class.

Remarks
  Only valid to call this after createParamDictionary.

Returns
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

## ◆ getParamDictionary() [2/2]

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const
| inline inherited

## ◆ getParameters()

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const
| inherited

Retrieves a list of parameters valid for this object.

Returns
  A reference to a static list of ParameterDef objects.

## ◆ setParameter()

bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value
| ) |  |
| inherited

Generic parameter setting method.

Remarks
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters

  name | The name of the parameter to set
  value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

Referenced by Ogre::StringInterface::copyParametersTo().

## ◆ setParameterList()

void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) |
| inherited

Generic multiple parameter setting method.

Remarks
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters

  paramList | Name/value pair list

## ◆ getParameter()

String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const
| inline inherited

Generic parameter retrieval method.

Remarks
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters

  name | The name of the parameter to get

Returns
  String value of parameter, blank if not found

References Ogre::ParamCommand::doGet().

## ◆ copyParametersTo()

void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const
| inline inherited

Method for copying this object's parameters to another object.

Remarks
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters

  dest | Pointer to object to have it's parameters set the same as this object.

References Ogre::StringInterface::setParameter().

## ◆ cleanupDictionary()

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) |
| static inherited

Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

MaterialManager) initializes.

The documentation for this class was generated from the following file:

- OgreParticleAffector.h